package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import org.pcap4j.packet.namednumber.NamedNumber;

import java.util.HashMap;
import java.util.Map;

public final class TLS_Enum_Alert_Level extends NamedNumber<Byte, TLS_Enum_Alert_Level> {
    public TLS_Enum_Alert_Level(Byte value, String name) {
        super(value, name);
    }
    public static final TLS_Enum_Alert_Level ALERT_LEVEL_WARNING
            = new TLS_Enum_Alert_Level((byte)1, "ALERT_LEVEL_WARNING");
    public static final TLS_Enum_Alert_Level ALERT_LEVEL_FATAL
            = new TLS_Enum_Alert_Level((byte)2, "ALERT_LEVEL_FATAL");


    private static final Map<Byte, TLS_Enum_Alert_Level> registry
            = new HashMap<Byte, TLS_Enum_Alert_Level>();

    static {
        registry.put(ALERT_LEVEL_WARNING.value(), ALERT_LEVEL_WARNING);
        registry.put(ALERT_LEVEL_FATAL.value(), ALERT_LEVEL_FATAL);
    }

    @Override
    public int compareTo(TLS_Enum_Alert_Level o) {
        return this.value().compareTo(o.value());
    }

    public static TLS_Enum_Alert_Level getInstance(Byte value) {
        if (registry.containsKey(value)) {
            return registry.get(value);
        }
        else {
            return new TLS_Enum_Alert_Level(value, "unknown");
        }
    }
}
