package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import org.pcap4j.packet.namednumber.NamedNumber;

import java.util.HashMap;
import java.util.Map;

public final class TLS_Enum_Extension_Type extends NamedNumber<Short, TLS_Enum_Extension_Type> {
    public TLS_Enum_Extension_Type(Short value, String name) {
        super(value, name);
    }
    public static final TLS_Enum_Extension_Type TLS_HANDSHAKE_EXTENSION_EC_POINT_FORMATS =
            new TLS_Enum_Extension_Type((short) 0x000b , "TLS_HANDSHAKE_EXTENSION_EC_POINT_FORMATS");
    public static final TLS_Enum_Extension_Type TLS_HANDSHAKE_EXTENSION_SERVER_NAME =
            new TLS_Enum_Extension_Type((short) 0x0000 , "TLS_HANDSHAKE_EXTENSION_SERVER_NAME");

    private static final Map<Short, TLS_Enum_Extension_Type> registry
            = new HashMap<Short, TLS_Enum_Extension_Type>();

    static {
        registry.put(TLS_HANDSHAKE_EXTENSION_EC_POINT_FORMATS.value(), TLS_HANDSHAKE_EXTENSION_EC_POINT_FORMATS);
        registry.put(TLS_HANDSHAKE_EXTENSION_SERVER_NAME.value(), TLS_HANDSHAKE_EXTENSION_SERVER_NAME);
    }
    @Override
    public int compareTo(TLS_Enum_Extension_Type o) {
        return this.value().compareTo(o.value());
    }

    public static TLS_Enum_Extension_Type getInstance(Short value) {
        if (registry.containsKey(value)) {
            return registry.get(value);
        }
        else {
            return new TLS_Enum_Extension_Type(value, "unknown");
        }
    }
}
