package edu.wpi.appjudicator.ssl.tls_packet_parsing;

public class TLS_Change_Cypher_Spec_Message implements TLS_Sublayer{
    byte msg;

    TLS_Change_Cypher_Spec_Message(byte[] raw_data, int start) {
        this.msg = raw_data[start];
    }

    TLS_Change_Cypher_Spec_Message() {
        this.msg = 0x01;
    }
    @Override
    public byte[] getRawData() {
        byte[] rd = new byte[1];
        rd[0] = msg;
        return rd;
    }

    @Override
    public int getTotalSize() {
        return 1;
    }

    public static class TLS_Change_Cypher_Spec_Message_Builder implements TLS_Builder<TLS_Change_Cypher_Spec_Message>{
        public TLS_Change_Cypher_Spec_Message_Builder() {

        }

        @Override
        public TLS_Change_Cypher_Spec_Message build() throws Exception {
            return new TLS_Change_Cypher_Spec_Message();
        }

        @Override
        public void fixSizeFields() {
            return;
        }

        @Override
        public int fixAndGetTotalSize() {
            return 1;
        }
    }

}
