package edu.wpi.appjudicator.ssl.tls_packet_parsing;

import edu.wpi.appjudicator.ssl.SSL_Helper;

public class TLS_Handshake_Extension_Factory {
    public TLS_Handshake_Extension_Abstract build(byte[] raw_data, int start) {
        TLS_Enum_Extension_Type handshake_type = TLS_Enum_Extension_Type.getInstance((short) SSL_Helper.convert_to_int(raw_data, start, 2));

        if (handshake_type.equals(TLS_Enum_Extension_Type.TLS_HANDSHAKE_EXTENSION_EC_POINT_FORMATS)) {
            return new TLS_Handshake_Extension_EC_POINT_FORMATS(raw_data, start);
        } else if (handshake_type.equals(TLS_Enum_Extension_Type.TLS_HANDSHAKE_EXTENSION_SERVER_NAME)) {
            return new TLS_Handshake_Extension_SERVER_NAME(raw_data, start);
        } else {
            return new TLS_Handshake_Extension_Unknown(raw_data, start);
        }
    }
}
